var SOURCE_ROOT = ".\\";
var CLASS_ROOT = ".\\";
var OUTPUT_ROOT = ".\\";

var debug = true;
var fso = WScript.CreateObject("Scripting.FileSystemObject");
var file = fso.openTextFile("ClassInternList.txt");

var dict = WScript.CreateObject("Scripting.Dictionary");
var interfaceDict = WScript.CreateObject("Scripting.Dictionary");

var s = file.readLine();
while( !file.AtEndOfStream )
{
   if(debug && s.indexOf("class")>=0)
      WScript.echo("found: " + s);

   var bAbstract = false;

   //add abstract classes to the list.
   if(s.indexOf("public abstract class")==0)
   {
      s = s.replace(" abstract","");
      if(debug)
         WScript.echo("class is abstract");
      bAbstract = true;
   }

   var tokens = s.split(" ");

   //create a list of all interfaces in a dict
   if(s.indexOf("public interface")==0)
   {
      if(debug)
         WScript.echo("class is public interface abstract");
      if(s.indexOf("Memory")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.ADContainer")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.ClockContainer")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.HumidityContainer")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.PotentiometerContainer")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.PasswordContainer")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.MissionContainer")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.SwitchContainer")>=0 ||
         s.indexOf("com.dalsemi.onewire.container.TemperatureContainer")>=0)
      {
	      if(debug)
            WScript.echo("class is memory or sensor");
         //it's a public Memory interface, so it gets added to our list.
         s = s.replace("public interface","public class");
         bAbstract = true;
         tokens = s.split(" ");
      }
      else
      {
         //make a list of the constants in the interface
         var constants = new Array();
         var done = false;
         while( !file.AtEndOfStream && !done )
         {
            s = file.readLine();
            if(s.indexOf("}")<0)
            {
               //remove leading spaces and semicolon from constant name
               s = s.replace(/ *(.*)/g,"$1").replace(";","");

               //make sure it's a constant and not an interface method
               if(s.indexOf("(")>=0)
                  continue;
               //ignore comments and beginning of class definition line
               if(s.indexOf("/*")>=0 || s.indexOf("{")>=0)
                  continue;
               //ignore non-public methods
               if(s.indexOf("public")<0)
                  continue;

               constants[constants.length] = s
            }
            else
               done = true;
         }
         if(constants.length>0)
            interfaceDict(tokens[2]) = constants;

         //done with this interface, continue the outer while loop
         continue;
      }

   }

   //only public classes and no exceptions or events
   if(s.indexOf("public class ")==0 &&
         s.indexOf("Exception ")<0 &&
         s.indexOf("Event")<0)
   {
      var classname = tokens[2];
      dict(classname) = WScript.CreateObject("Scripting.Dictionary");
      dict(classname)("abstract") = bAbstract;

      var superclassname = tokens[4];
      dict(classname)("extends") = superclassname;
      dict(classname)("hasNonDefaultConstructor") = false;

      var i = s.indexOf("implements");
      if(i>0)
      {
         var interfaces = s.substring(i+11)
         i = interfaces.indexOf("{");
         if(i>=0)
            interfaces = interfaces.substring(0,i);
         dict(classname)("implements") = interfaces.split(", ");
         if(debug && classname.indexOf("OneWireContainer")>0)
            WScript.echo("   " + classname.replace("com.dalsemi.onewire.container.","")
                         + " implements "
                         + (dict(classname)("implements")+"").replace("com.dalsemi.onewire.container.",""));
      }

      dict(classname)("hasDefaultConstructor") = false;
      var methods = new Array();
      var createMethods = new Array();
      var done = false;
      while( !file.AtEndOfStream && !done )
      {
         s = file.readLine();
         done = (s.indexOf("}")>=0);
         if(!done)
         {
            //remove leading spaces and semicolon from method name
            s = s.replace(/ *(.*);/g,"$1");

            //ignore comments and beginning of class definition line
            if(s.indexOf("/*")>=0 || s.indexOf("{")>=0)
               continue;
            //ignore non-public methods
            if(s.indexOf("public")<0)
               continue;
            //ignore native methods
            if(s.indexOf("native")>=0)
               continue;

            //ignore some constructors
            if(s.indexOf("public " + classname + "(")>=0)
            {
               //if it's a default constructor, note that it has one
               if(s.indexOf("public " + classname + "()")>=0)
               {
                  if(s.indexOf("throws")>0)
                     dict(classname)("hasDefaultConstructor") = s.substring(s.indexOf("throws"));
                  else
                     dict(classname)("hasDefaultConstructor") = 1;
                  continue;
               }
               else
               {
                  dict(classname)("hasNonDefaultConstructor") = true;

                  //if it's a subclass of OneWireContainer, ignore all
                  //public constructors
                  if(classname.indexOf("OneWireContainer")>=0)
                     continue;
               }
            }
            //ignore main method
            if(s.indexOf("public static void main")>=0)
               continue;
            s = s.replace(" abstract","");
            methods[methods.length] = s
         }
      }
      dict(classname)("methods") = methods;
      dict(classname)("createMethods") = createMethods;
      if(debug)
         WScript.echo("Class added:" + classname);

      continue;
   }
   s = file.readLine();
}

if(debug)
   WScript.echo("done loading collection");
var keys = new VBArray(dict.Keys()).toArray();

// regular expression for getting the package off the class name
var regPkg = new RegExp("com\\.dalsemi\\.onewire\\..*\\.([^ ]*) ","");

var classIDs = getClassIDs();

// create a diffences File
WScript.CreateObject("Scripting.FileSystemObject");
var differences = fso.createTextFile("differences.txt");
for(var i=0; i<keys.length; i++)
{
   var className = keys[i];
   var j = className.lastIndexOf(".");
   var smallClassName = className.substring(j+1);
   if(smallClassName=="LSerialAdapter" || smallClassName=="USerialAdapter" || smallClassName=="DumbAdapter")
      //don't include these files
      continue;

   var isContainerSensorInterface = false;
   if(smallClassName=="ADContainer" ||
      smallClassName=="ClockContainer" ||
      smallClassName=="HumidityContainer" ||
      smallClassName=="PotentiometerContainer" ||
      smallClassName=="PasswordContainer" ||
      smallClassName=="MissionContainer" ||
      smallClassName=="SwitchContainer" ||
      smallClassName=="TemperatureContainer")
   {
      isContainerSensorInterface = true;
   }

   if(debug)
   {
      WScript.echo();
      WScript.echo("-------------------------------------------------------------------");
      WScript.echo("creating: owapi\\" + smallClassName + ".java");
   }

   var f = fso.createTextFile(
         "owapi\\" +
            smallClassName + ".java");

   f.writeLine("// COM proxy class, output from FunctionList.js");
   f.writeLine("package owapi;");

   var a = dict(className);
   var methods = a("methods");

   var classDoc = getClassDocumentation(className,smallClassName);
   if(classIDs(smallClassName))
   {
      if(classDoc.indexOf("@version")>=0)
      {
         classDoc = classDoc.replace("@version",
               "@version CLSID=" +
               classIDs(smallClassName) + " - ");
         classDoc = classDoc.replace(" */",
               " * @com.register ( clsid=" + classIDs(smallClassName)
                              + ", typelib=" + classIDs("typelib") + " )\r\n */");
      }
      else
      {
         classDoc = classDoc.replace(" */",
               " * @com.register ( clsid=" + classIDs(smallClassName)
                              + ", typelib=" + classIDs("typelib") + " )\r\n"
                              + " * @version CLSID=" + classIDs(smallClassName) + "\r\n */");
      }
   }
   else
   {
      WScript.echo("   No COM CLSID for " + smallClassName);
   }
   f.write(classDoc);
   if(!isContainerSensorInterface)
      f.writeLine("public class " + smallClassName);
   else
      f.writeLine("public interface " + smallClassName);

   differences.writeLine("-------------------------------------------------------------")
   differences.writeLine(className);
   differences.writeLine(" -> public class " + smallClassName);


   var bHasSuperClass = (typeof dict(a("extends")) != "undefined");
   var superClass = "";
   var topMostSuperClass = "";
   if(bHasSuperClass)
   {
      var superClassName = a("extends");
      superClass = superClassName.substring(superClassName.lastIndexOf(".")+1);
      topMostSuperClass = superClass;
      while(dict(superClassName) && dict(superClassName)("extends"))
      {
         superClassName = dict(superClassName)("extends");
         if(debug)
            WScript.echo("superClassName="+superClassName);
         if(superClassName!="java.lang.Object")
            topMostSuperClass = superClassName.substring(superClassName.lastIndexOf(".")+1);
      }
   }
   else
      topMostSuperClass = smallClassName;

   //get the methods list for this class
   var uniqueMethods;
   if(bHasSuperClass)
      f.writeLine("   extends " + superClass);

   if(classIDs(smallClassName))
      f.write("   implements com.ms.com.IUnknown");
   var interfacesImplemented = a("implements");
   if(interfacesImplemented)
   {
      if(debug && smallClassName.indexOf("OneWireContainer")>=0)
      {
         WScript.echo("-->" + smallClassName + " implements " + interfacesImplemented);
      }
      for(var intCnt=0; intCnt<interfacesImplemented.length; intCnt++)
      {
         if(interfacesImplemented[intCnt].indexOf("ADContainer")>=0 ||
            interfacesImplemented[intCnt].indexOf("ClockContainer")>=0 ||
            interfacesImplemented[intCnt].indexOf("HumidityContainer")>=0 ||
            interfacesImplemented[intCnt].indexOf("PotentiometerContainer")>=0 ||
            interfacesImplemented[intCnt].indexOf("PasswordContainer")>=0 ||
            interfacesImplemented[intCnt].indexOf("MissionContainer")>=0 ||
            interfacesImplemented[intCnt].indexOf("SwitchContainer")>=0 ||
            interfacesImplemented[intCnt].indexOf("TemperatureContainer")>=0)
         {
            if(debug)
               WScript.echo(smallClassName + " implements " + interfacesImplemented[intCnt]);
            f.write(", " + interfacesImplemented[intCnt].replace("com.dalsemi.onewire.container.",""))
         }
         else
         {
            //if this class implements an interface, let's propogate the
            //interface constants to this class
            var interfaceConstants = interfaceDict(interfacesImplemented[intCnt]);
            if(interfaceConstants && interfaceConstants.length>0)
            {
               var newMethods = new Array();
               for(var intCnt=0;intCnt<interfaceConstants.length;intCnt++)
                  newMethods[newMethods.length] = interfaceConstants[intCnt];
               for(var methCnt=0;methCnt<methods.length;methCnt++)
                  newMethods[newMethods.length] = methods[methCnt];
               methods = newMethods;
            }
         }
      }
   }
   //of the collection of methods, we're only interested in
   //methods that don't exist in a super class
   uniqueMethods = checkSuper(a("extends"),methods);

   f.writeLine("");
   f.writeLine("{");
   f.writeLine("");

   var bAllStatic = (uniqueMethods.length>0);
   for(var j=0; j<uniqueMethods.length && bAllStatic; j++)
   {
      if(uniqueMethods[j].indexOf("static")<0)
         bAllStatic = false;
   }

   if(!bAllStatic && !isContainerSensorInterface)
   {
      if(bHasSuperClass)
      {
         //constructors for sub-classes
         f.writeLine("   //Instance defined in super class: " + superClass);
         f.writeLine("   //" + className + " objectInstance " + " = null;");
         f.writeLine("");
         var doc = "   /**\r\n" +
                   "    * Default constructor.";
         if(a("hasDefaultConstructor") && a("hasDefaultConstructor")!=1)
            doc += " Calls default constructor of representative class.";
         else
            doc += " Does nothing.";
         
         if(className.indexOf("OneWireContainer")>0)
            doc += " Use setupContainer or buildFromObject methods initialize.";
         else if(className.indexOf("MemoryBank")>0)
            doc += " Use buildFromObject method to initialize.";
         else if(a("hasNonDefaultConstructor"))
            doc += " Use createNewInstance methods to call a specific constructor.";
            
         doc += "\r\n    */";
         f.writeLine(doc);
         f.writeLine("   public " + smallClassName + "()");
         if(a("hasDefaultConstructor") && a("hasDefaultConstructor")!=1)
            f.writeLine("      " + a("hasDefaultConstructor"));
         f.writeLine("   {");
         if(!a("abstract") && a("hasDefaultConstructor"))
            f.writeLine("      super(new " + className + "());");
         f.writeLine("   }");
         f.writeLine("");
         f.writeLine("   " + smallClassName + "(" + className + " o)");
         f.writeLine("   {");
         f.writeLine("      super(o);");
         f.writeLine("   }");
         f.writeLine("   " + smallClassName + "(java.lang.Object o)");
         f.writeLine("   {");
         f.writeLine("      super((" + className + ")o);");
         f.writeLine("   }");
      }
      else
      {
         //constructors for top-level classes
         f.writeLine("   " + className + " objectInstance " + " = null;");
         f.writeLine("");
         var doc = "   /**\r\n" +
                   "    * Default constructor.";
                   
         if(a("hasDefaultConstructor") && a("hasDefaultConstructor")!=1)
            doc += " Calls default constructor of representative class.";
         else
            doc += " Does nothing.";
         
         if(a("hasNonDefaultConstructor"))
            doc += " Use createNewInstance methods to call a specific constructor.";
            
         doc += "\r\n    */";
         f.writeLine(doc);
         f.writeLine("   public " + smallClassName + "()");
         if(a("hasDefaultConstructor") && a("hasDefaultConstructor")!=1)
            f.writeLine("      " + a("hasDefaultConstructor"));
         f.writeLine("   {");
         if(!a("abstract") && a("hasDefaultConstructor"))
            f.writeLine("      this.objectInstance = new " + className + "();");
         f.writeLine("   }");
         f.writeLine("");
         f.writeLine("   " + smallClassName + "(" + className + " o)");
         f.writeLine("   {");
         f.writeLine("      this.objectInstance = o;");
         f.writeLine("   }");
         f.writeLine("   " + smallClassName + "(java.lang.Object o)");
         f.writeLine("   {");
         f.writeLine("      this.objectInstance = ((" + className + ")o);");
         f.writeLine("   }");
      }
   }
   f.writeLine("");

   var duplicationCheck = new Array();
   for(var j=0; j<uniqueMethods.length; j++)
   {
      var isConstructor = false;
      var sMethodSig = uniqueMethods[j];
      if(debug)
      {
         WScript.echo(" ");
         WScript.echo(" ======================================  ");
         WScript.echo("  " + sMethodSig);
      }

      // no support for event listeners
      if(sMethodSig.indexOf("EventListener")>=0)
      {
         WScript.echo("No support: " + sMethodSig);
         continue;
      }

      var reg = new RegExp("(.*)\\((.*)\\)([\\[\\]]*) ?(.*)","g")
      if(!sMethodSig.match(reg))
      {
         //Check for ambiguous ALARM_HIGH and ALARM_LOW
         if((sMethodSig.indexOf("ALARM_HIGH")>=0 || sMethodSig.indexOf("ALARM_LOW")>=0) &&
            (interfacesImplemented + "").indexOf("TemperatureContainer")>=0)
         {
            // it's not a method, but a public constant
            var name = sMethodSig.substring(sMethodSig.lastIndexOf(" ")+1);
            f.writeLine("   " + sMethodSig);
            f.writeLine("          = com.dalsemi.onewire.container.TemperatureContainer." + name + ";");
            f.writeLine("");
         }
         else if(sMethodSig.indexOf("final")>=0 && sMethodSig.indexOf("static")>=0)
         {
            // it's not a method, but a public constant
            var name = sMethodSig.substring(sMethodSig.lastIndexOf(" ")+1);
            f.writeLine("   " + sMethodSig);
            f.writeLine("          = " + className + "." + name + ";");
            f.writeLine("");
         }
         continue;
      }

      var sMethodName = RegExp.$1;
      if(debug) WScript.echo("sMethodName=" + sMethodName);
      var sParams = RegExp.$2;
      if(debug) WScript.echo("sParams=" + sParams);
      var sThrows = RegExp.$4;
      if(debug) WScript.echo("sThrows=" + sThrows);

      var arrMethodName = sMethodName.split(" ");
      var z = 0;
      while( (arrMethodName[z]=="public" ||
              arrMethodName[z]=="static" ||
              arrMethodName[z]=="final" ||
              arrMethodName[z]=="synchronized") && z<(arrMethodName.length) )
         z++; //index of return value

      var bReturnsArray = false;
      if(z<(arrMethodName.length-1) && RegExp.$3)
      {
         bReturnsArray = true;
         arrMethodName[z] += RegExp.$3;
         sMethodName = (String(arrMethodName)).replace(/,/g," ");
      }

      //Change the return value
      var enumerationType = false;
      var sNewMethodName = "";
      if(z==(arrMethodName.length-1))
      {
         //has no return value, it's a public constructor
         isConstructor = true;
         sMethodName = "public void createNewInstance"
         sNewMethodName =  sMethodName;
         arrMethodName = sMethodName.split(" ");
         z = 1;
      }
      else if(arrMethodName[z] == "long")
      {
         sNewMethodName = (sMethodName).replace("long","String");
      }
      else if(arrMethodName[z] == "byte[]")
      {
         sNewMethodName = (sMethodName).replace("byte[]","ByteArray");
      }
      else if(arrMethodName[z] == "boolean[]")
      {
         sNewMethodName = (sMethodName).replace("boolean[]","BooleanArray");
      }
      else if(arrMethodName[z] == "long[]")
      {
         sNewMethodName = (sMethodName).replace("long[]","LongArray");
      }
      else if(arrMethodName[z] == "int[]")
      {
         sNewMethodName = (sMethodName).replace("int[]","IntArray");
      }
      else if(arrMethodName[z] == "char[]")
      {
         sNewMethodName = (sMethodName).replace("char[]","CharArray");
      }
      else if(arrMethodName[z] == "float[]")
      {
         sNewMethodName = (sMethodName).replace("float[]","FloatArray");
      }
      else if(arrMethodName[z] == "double[]")
      {
         sNewMethodName = (sMethodName).replace("double[]","DoubleArray");
      }
      else if(arrMethodName[z] == "com.dalsemi.onewire.container.OneWireContainer[]")
      {
         sNewMethodName = (sMethodName).replace("com.dalsemi.onewire.container.OneWireContainer[]","OneWireContainerArray");
      }
      else if(arrMethodName[z] == "com.dalsemi.onewire.application.file.OWFile[]")
      {
         sNewMethodName = (sMethodName).replace("com.dalsemi.onewire.application.file.OWFile[]","OWFileArray");
      }
      else if(arrMethodName[z]=="java.util.Enumeration")
      {
         if(sMethodName.indexOf("enumerateAllAdapters")>0)
            enumerationType = "DSPortAdapterEnumeration";
         else if(sMethodName.indexOf("getAllDeviceContainers")>0)
            enumerationType = "OneWireContainerEnumeration";
         else if(sMethodName.indexOf("getMemoryBanks")>0)
            enumerationType = "MemoryBankEnumeration";
         else if(sMethodName.indexOf("getAllOWPathElements")>0)
            enumerationType = "OWPathEnumeration";
         else if(sMethodName.indexOf("getPortNames")>0 || sMethodName.indexOf("getAllAddresses")>0)
            enumerationType = "StringEnumeration";
         sNewMethodName = (sMethodName).replace("java.util.Enumeration", enumerationType);
         
      }
      else if(sMethodName.match(regPkg)) //replace with COM component
      {
         sNewMethodName = sMethodName.replace(regPkg,RegExp.$1 + " ");
      }
      else
      {
         sNewMethodName = sMethodName;
      }

      //build the argument list for the method we're calling
      var sMethodCallArgs = "";
      var sArgumentModifications = "";
      // and the parameter list for the method we're writing
      var sNewMethodParams = "";
      var arrParams = sParams.split(/[, ]+/);
      if(sParams.length>0)
      {
         for(var t=0; t<arrParams.length; t++)
         {
            WScript.echo("t"+t+",arrParams[t]=" + arrParams[t]);
            if((arrParams[t]+"")!="com.dalsemi.onewire.container.OneWireContainer[]"
               && (arrParams[t]+"")!="comd.dalsemi.onewire.application.file.OWFile[]"
               && (arrParams[t]+" ").match(regPkg))
            {
               if(interfaceDict(arrParams[t]))
               {
                  sNewMethodParams += arrParams[t] + " a" + t + ", ";
                  sMethodCallArgs += "a" + t + ", ";
               }
               else
               {
                  sNewMethodParams += RegExp.$1 + " a" + t + ", ";
                  WScript.echo("t"+t+",sNewMethodParams=" + sNewMethodParams);
                  if(RegExp.$1.indexOf("[]")>=0)
                  {
                     sArgumentModifications = arrParams[t] + " aMOD" + t +
                        " = new " + arrParams[t].replace("[]","[a" + t + ".length]") + ";\r\n";
                     sArgumentModifications += "      for(int i=0; i<a" + t + ".length; i++) \r\n";
                     sArgumentModifications += "         aMOD" + t + "[i] = a" + t + "[i].objectInstance;\r\n      ";
                     sMethodCallArgs += "aMOD" + t + ", ";
                  }
                  else
                  {
                     sMethodCallArgs += "(("+arrParams[t]+")a" + t + ".objectInstance), ";
                  }
               }
            }
            else
            {
               sNewMethodParams += COMtype(arrParams[t]) + " a" + t + ", ";
               sMethodCallArgs += unCOMtype(arrParams[t], "a" + t) + ", ";
            }
         }

         // fix ADConvert method for all classes
         if(sMethodName.indexOf("doADConvert")>=0 && sParams.indexOf("boolean[]")>=0)
            sNewMethodName += "Multi";

         // do individual class method fixes
         if(smallClassName=="SHAiButtonCoprVM")
         {
            if(sMethodName=="public void createNewInstance" ||
               sMethodName=="public boolean load")
            {
               if(sParams.indexOf("OneWireContainer18")<0)
                  sNewMethodName += "FromContainer";
            }
         }
         else if(smallClassName=="SHAiButtonUser18" || smallClassName=="SHAiButtonUser33")
         {
            if(sParams.indexOf("SHAiButtonCopr")<0)
               sNewMethodName += "FromCoprocessor";
         }
         else if(smallClassName=="CommandAPDU")
         {
            if(sMethodName=="public void createNewInstance")
            {
               if(sParams.indexOf("int")>=0)
                  sNewMethodName += "FromInt";
            }
         }
         else if(smallClassName=="OWFile")
         {
            if(sMethodName=="public void createNewInstance")
            {
               if (sParams.indexOf("OneWireContainer[]")>=0)
                  sNewMethodName += "FromContainers";
               else if (sParams.indexOf("OneWireContainer")>=0)
                  sNewMethodName += "FromContainer";
            }
            else if(sMethodName=="public int compareTo")
            {
               if(sParams.indexOf("OWFile")>=0)
                  //skip this method
                  continue;
            }
            else if(sMethodName=="public boolean delete")
            {
               sNewMethodName += "File";
            }
         }
         else if(smallClassName=="OWFileInputStream")
         {
            if(sMethodName=="public void createNewInstance")
            {
               if (sParams.indexOf("OneWireContainer[]")>=0)
                  sNewMethodName += "FromContainers";
               else if (sParams.indexOf("OneWireContainer")>=0)
                  sNewMethodName += "FromContainer";
               else if (sParams.indexOf("OWFileDescriptor")<0 &&
                        sParams.indexOf("OWFile")>=0)
                  sNewMethodName += "FromFile";
            }
         }
         else if(smallClassName=="OWFileOutputStream")
         {
            if(sMethodName=="public void createNewInstance")
            {
               if (sParams.indexOf("OneWireContainer[]")>=0)
                  sNewMethodName += "FromContainers";
               else if (sParams.indexOf("OneWireContainer")>=0)
                  sNewMethodName += "FromContainer";
               else if (sParams.indexOf("OWFileDescriptor")<0 &&
                        sParams.indexOf("OWFile")>=0)
                  sNewMethodName += "FromFile";
            }
            else if (sMethodName=="public void write")
            {
               if(sParams.indexOf("byte[]")>=0)
                  sNewMethodName += "FromBytes";
            }
         }
         else if(smallClassName=="CRC16" || smallClassName=="CRC8")
         {
            if(sMethodName=="public static int compute")
            {
               if(sParams.indexOf("byte[]")>=0)
                  sNewMethodName += "FromBytes";
            }
         }
         else if(smallClassName=="OneWireContainer")
         {
            if(sMethodName=="public void setupContainer")
            {
               if(sParams.indexOf("byte[]")>=0)
                  sNewMethodName += "FromBytes";
               else if(sParams.indexOf("long")>=0)
                  sNewMethodName += "FromLong";
            }
         }
         else if(smallClassName=="DSPortAdapter")
         {
            if(sMethodName=="public boolean isAlarming" ||
               sMethodName=="public boolean isPresent" ||
               sMethodName=="public boolean select" ||
               sMethodName=="public void assertSelect" ||
               sMethodName=="public void targetFamily" ||
               sMethodName=="public void excludeFamily" ||
               sMethodName=="public com.dalsemi.onewire.container.OneWireContainer getDeviceContainer")
            {
               if(sParams.indexOf("byte[]")>=0)
                  sNewMethodName += "FromBytes";
               else if(sParams.indexOf("long")>=0)
                  sNewMethodName += "FromLong";
            }
         }
         else if(smallClassName=="DumbAdapter")
         {
            if(sMethodName=="public boolean isAlarming" ||
               sMethodName=="public boolean isPresent")
            {
               if(sParams.indexOf("byte[]")>=0)
                  sNewMethodName += "FromBytes";
               else if(sParams.indexOf("long")>=0)
                  sNewMethodName += "FromLong";
            }
         }
         else if(smallClassName=="Address")
         {
            if(sMethodName=="public static boolean isValid" ||
               sMethodName=="public static java.lang.String toString" ||
               sMethodName=="public static long toLong" ||
               sMethodName=="public static byte[] toByteArray")
            {
               if(sParams.indexOf("byte[]")>=0)
                  sNewMethodName += "FromBytes";
               else if(sParams.indexOf("long")>=0)
                  sNewMethodName += "FromLong";
            }
         }
         else if(smallClassName=="Debug")
         {
            if(sMethodName=="public static final void debug")
            {
               if(sParams.indexOf("java.lang.Throwable")>=0)
                  sNewMethodName += "WithException";
            }
         }
         else if(smallClassName=="Convert")
         {
            /*if(sMethodName=="public static final long toLong" ||
               sMethodName=="public static final int toInt")
            {
               if(sParams.indexOf("String")==0)
                  sNewMethodName += "FromString";
               else if(sParams.indexOf("byte[]")==0)
                  sNewMethodName += "FromBytes";
               else if(sParams.indexOf("char[]")==0)
                  sNewMethodName += "FromChars";
               else if(sParams.indexOf("int")==0)
                  sNewMethodName += "FromInt";
               else if(sParams.indexOf("long")==0)
                  sNewMethodName += "FromLong";
            }
            else if(sMethodName=="public static final byte[] toByteArray" ||
                    sMethodName=="public static final void toByteArray")
            {
               if(sParams.indexOf("int")==0)
                  sNewMethodName += "FromInt";
               else if(sParams.indexOf("long")==0)
                  sNewMethodName += "FromLong";
            */
               if(sParams.indexOf("java.lang.String")==0)
                  sNewMethodName += "FromHexString";
            //}
            //else if(sMethodName=="public static final java.lang.String toHexString")
            //{
               else if(sParams.indexOf("int")==0)
                  sNewMethodName += "FromInt";
               else if(sParams.indexOf("long")==0)
                  sNewMethodName += "FromLong";
               else if(sParams.indexOf("byte\[\]")==0)
                  sNewMethodName += "FromBytes";
               else if(sParams.indexOf("byte")==0)
                  sNewMethodName += "FromByte";
               else if(sParams.indexOf("char[]")==0)
                  sNewMethodName += "FromChars";
               else if(sParams.indexOf("char")==0)
                  sNewMethodName += "FromChar";
            //}
            //else if(sMethodName=="public static final java.lang.String toString")
            //{
               else if(sParams.indexOf("float")==0)
                  sNewMethodName += "FromFloat";
               else if(sParams.indexOf("double")==0)
                  sNewMethodName += "FromDouble";
            //}
            if(debug)
               WScript.echo("Convert method update: " + sMethodName + " {" + sParams + "} -> " + sNewMethodName);
         }
         else if(smallClassName=="NetAdapterHost")
         {
            if(sMethodName=="public void createNewInstance")
            {
               if(sParams.indexOf("Socket")>=0)
                  sNewMethodName += "FromSocket";
               if(sParams.indexOf("boolean")>=0)
                  sNewMethodName += "Multithreaded";
            }
         }
         else if(smallClassName=="NetAdapter")
         {
            if(sMethodName=="public boolean selectPort")
            {
               if(sParams.indexOf("Socket")>=0)
                  sNewMethodName += "FromSocket";
            }
         }
         else if(smallClassName=="SAXParser")
         {
            if(sMethodName=="public void parse")
            {
               if(sParams.indexOf("org.xml.sax.InputSource")>=0)
                  sNewMethodName += "FromInputSource";
            }
         }
         else if(smallClassName=="AbstractDeviceMonitor")
         {
            if(sMethodName=="public com.dalsemi.onewire.utils.OWPath getDevicePath" ||
               sMethodName=="public static com.dalsemi.onewire.container.OneWireContainer getDeviceContainer" ||
               sMethodName=="public static void putDeviceContainer")
            {
               if(sParams.indexOf("String")>=0)
                  sNewMethodName += "FromString";
               else if(sParams.indexOf("byte[]")>=0)
                  sNewMethodName += "FromBytes";
               else if(sParams.indexOf("long")>=0)
                  sNewMethodName += "FromLong";
               else if(sParams.indexOf("java.lang.Long")>=0)
                  sNewMethodName += "FromLongObject";
            }
         }

         sNewMethodParams = sNewMethodParams.substring(0,sNewMethodParams.lastIndexOf(", "));
         sMethodCallArgs = sMethodCallArgs.substring(0,sMethodCallArgs.lastIndexOf(", "));
      }

      // add to our list of method names and parameters
      var tempMethodName = sNewMethodName + (sParams.length==0?0:arrParams.length);
      if(debug) WScript.echo("tempMethodName=" + tempMethodName);
      if(duplicationCheck[tempMethodName])
      {
         WScript.echo("ERROR: in class " + className + " duplicate method " + sNewMethodName + " with " + arrParams.length + " parameters (" + sParams + ") <-> (" + duplicationCheck[tempMethodName] + ")");
         continue;
      }
      else
      {
         duplicationCheck[tempMethodName] = "" + arrParams;
      }

      if(sMethodName=="public void createNewInstance")
         differences.writeLine("   public " + smallClassName + "(" + sParams + ")");
      else
         differences.writeLine("   " + sMethodName + "(" + sParams + ")");
      differences.writeLine("     ->" + sNewMethodName + "(" + sNewMethodParams + ")");

      //build the new proxy method
      var sNewMethod = "   " + sNewMethodName + "(" + sNewMethodParams + ")"
      if(sThrows.indexOf("throws")>=0)
         sNewMethod += "\n      " + sThrows;
      if(isContainerSensorInterface)
      {
         sNewMethod += ";\n";
      }
      else
      {
         sNewMethod += "\n   {      \n      ";
         if(sArgumentModifications!="")
            sNewMethod += sArgumentModifications;

         //Check if anything needs to be returned
         var bNeedsClose = false; //close parentheses after value
         var bNeedsRelooping = false;
         var sLoopType = null;
         var sLoopVar = null;

         if(arrMethodName[z]=="long")
         {
            sNewMethod += "return \"\"+";
         }
         else if(arrMethodName[z]=="byte[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new ByteArray().setupObject(";
         }
         else if(arrMethodName[z]=="boolean[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new BooleanArray().setupObject(";
         }
         else if(arrMethodName[z]=="char[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new CharArray().setupObject(";
         }
         else if(arrMethodName[z]=="int[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new IntArray().setupObject(";
         }
         else if(arrMethodName[z]=="long[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new LongArray().setupObject(";
         }
         else if(arrMethodName[z]=="float[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new FloatArray().setupObject(";
         }
         else if(arrMethodName[z]=="double[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new DoubleArray().setupObject(";
         }
         else if(arrMethodName[z]=="com.dalsemi.onewire.container.OneWireContainer[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new OneWireContainerArray().setupObject(";
         }
         else if(arrMethodName[z]=="com.dalsemi.onewire.application.file.OWFile[]")
         {
            bNeedsClose = true;
            sNewMethod += "return new OWFileArray().setupObject(";
         }
         else if(arrMethodName[z]=="java.util.Enumeration")
         {
            //bNeedsRelooping = true;
            //sLoopType = "Enumeration";
            bNeedsClose = true;
            sNewMethod += "return new "+enumerationType+"().setupObject(";
         }
         else if(sMethodName.match(regPkg))
         {
            if(RegExp.$1.indexOf("[]")>=0)
            {
               bNeedsRelooping = true;
               sLoopType = "Array";
               sLoopVar = RegExp.$1.replace("[]","");
               sNewMethod += arrMethodName[z] + " retArray = ";
            }
            else
            {
               bNeedsClose = true;
               sNewMethod += "return new " + RegExp.$1 + "("
            }
         }
         else if(arrMethodName[z]!="void")
            sNewMethod += "return ";


         // create the line of code that actually calls the right method
         var sMethodCall = sMethodName.substring(sMethodName.lastIndexOf(" ")+1);

         if(isConstructor)
         {
            // constructor call, so create new instance
            sNewMethod += "objectInstance = new " + className;
            sMethodCall = "";
         }
         else if(sNewMethodName.indexOf("static")>=0)
         {
            sNewMethod = sNewMethod.replace(" static","");
            sNewMethod += className + ".";
         }
         else if(bHasSuperClass)
            sNewMethod += "(("+className+")objectInstance).";
         else
            sNewMethod += "objectInstance.";

         sNewMethod += sMethodCall;
         sNewMethod += "(" + sMethodCallArgs + ")";
         if(bNeedsClose)
            sNewMethod += ")";
         sNewMethod += ";\n"; //end of line for method call

         if(bNeedsRelooping)
         {
            var retype = null;
            if(sMethodCall=="getAllDeviceContainers")
               retype = "OneWireContainer";
            else if(sMethodCall=="enumerateAllAdapters")
               retype = "DSPortAdapter";
            else if(sMethodCall=="getMemoryBanks")
               retype = "MemoryBank";
            else if(sMethodCall=="getAllOWPathElements")
               retype = "OWPath";
            else if(sMethodCall=="listFiles" || sMethodCall=="listRoots")
               retype = "OWFile";

            if(sLoopType=="Array")
            {
               var reTypingLogic = getRetypeLogic(retype,"retArray[i]","reRetArray[i]");
               sNewMethod += "      " + sLoopVar + "[] reRetArray = ";
               sNewMethod += "new " + sLoopVar + "[retArray.length];\n";
               sNewMethod += "      for(int i=0; i<retArray.length; i++)\n";
               sNewMethod += "      {\n         /*Double Check This*/\n";
               if(reTypingLogic!=null)
                  sNewMethod += reTypingLogic + "\n"
               else
                  sNewMethod += "         reRetArray[i] = (new " + sLoopVar + "(null)).setupObject(retArray[i]);\n";
               sNewMethod += "      }\n";
               sNewMethod += "      return reRetArray;\n";
            }
            else if(sLoopType=="Enumeration")
            {
               /*var reTypingLogic = getRetypeLogic(retype,"o","o");
               if(reTypingLogic==null)
                  sNewMethod += "      return retEnum;//EnumNotUpdated\n";
               else
               {
                  sNewMethod += "      java.util.Vector reRetEnum = ";
                  sNewMethod += "new java.util.Vector();\n";
                  sNewMethod += "      while(retEnum.hasMoreElements())\n";
                  sNewMethod += "      {\n         \n";
                  sNewMethod += "         Object o = retEnum.nextElement();\n";
                  sNewMethod += reTypingLogic + "\n";
                  sNewMethod += "         reRetEnum.addElement(o);\n";
                  sNewMethod += "      }\n";
                  sNewMethod += "      return reRetEnum.elements();\n";
               }*/
            }
         }

         sNewMethod += "   }\n";
      }

      // try to load documentation
      var doc = getMethodDocumentation(className, smallClassName, sMethodName, arrParams);
      var parameterList = RegExp.$1;
      if(sNewMethod.indexOf("escape(")>=0)
         WScript.echo("parameterList=" + parameterList);
      if(parameterList)
      {
         parameterList = parameterList.split(/, */);
         for(var paramIndex=0; paramIndex<parameterList.length; paramIndex++)
         {
            var parameterEntry = parameterList[paramIndex];
            parameterEntry = parameterEntry.substring(parameterEntry.indexOf(" ") + 1);
            parameterEntry = parameterEntry.replace(/\[\]/g,"");
            if(parameterEntry)
            {
               if(sNewMethod.indexOf("escape(")>=0)
               {
                  WScript.echo("a" + paramIndex + "=>" + parameterEntry);
                  while(sNewMethod.indexOf("a" + paramIndex)>0)
                  {
                     sNewMethod = sNewMethod.replace("a" + paramIndex, parameterEntry);
                  }
               }
               else
               {
                  while(sNewMethod.indexOf("a" + paramIndex)>0)
                     sNewMethod = sNewMethod.replace("a" + paramIndex, parameterEntry);
               }
            }
         }
      }
      sNewMethod = doc + sNewMethod;

      f.writeLine(sNewMethod);
      if(debug) WScript.echo(sNewMethod);
   }

   //Get extra helpers for each class
   f.writeLine(getAdditionalMethods(className));

   if(!bAllStatic && !isContainerSensorInterface)
   {
      f.writeLine("\n   /** Sets this object's reference to null */");
      f.writeLine("   public void freeObject()");
      f.writeLine("   {");
      f.writeLine("      this.objectInstance = null;");
      f.writeLine("   }");
      f.writeLine("\n   /** Returns true if this COM Stub class refers to an object which is not null */");
      f.writeLine("   public boolean isObjectInitialized()");
      f.writeLine("   {");
      f.writeLine("      return this.objectInstance != null;");
      f.writeLine("   }");
      f.writeLine("\n   " + topMostSuperClass + " setupObject(Object o)");
      f.writeLine("   {");
      f.writeLine("      this.objectInstance = (" + className + ")o;");
      f.writeLine("      return this;");
      f.writeLine("   }");
   }

   //end the class
   f.writeLine("}");
}

// very brute force function
function getMethodDocumentation(className, smallClassName, methodName, params)
{
   if(debug)
   {
      WScript.echo("getMethodDocumentation");
      WScript.echo("   className="+className);
      WScript.echo("   methodName="+methodName);
      WScript.echo("   params="+params);
   }

   // create a regular expression for matching the right method
   var methodMatcher = "";
   if(methodName.indexOf("createNewInstance")>=0)
   {
      methodMatcher = smallClassName + " *\\((.*"
   }
   else
   {
      methodName.match(/public +(.*) +(.*)/);
      var returnValue = RegExp.$1;
      var callingName = RegExp.$2;
      returnValue = returnValue.replace("final ","");
      returnValue = returnValue.replace("synchronized ","");
      returnValue = returnValue.replace("static ","");
      returnValue = returnValue.replace(/\[\]/g, "\\[\\]");
      if(returnValue.indexOf(".")>=0)
         returnValue = returnValue.substring(returnValue.lastIndexOf(".")+1);
      methodMatcher = returnValue + " " + callingName + " *\\((.*"
   }
   //WScript.echo("after name mashing: " + methodMatcher);
   if(params.length>0)
   {
      var paramIndex;
      for(paramIndex=0; paramIndex<params.length; paramIndex++)
      {
         var param = params[paramIndex];
         if(param.indexOf(".")>=0)
            param = param.substring(param.lastIndexOf(".")+1);
         param = param.replace("final ","");
         param = param.replace("byte[]", "byte.*[]");
         param = param.replace(/\[\]/g, "\\[\\]");
         methodMatcher += param + ".*";
      }
   }
   methodMatcher += ")\\)";
   //WScript.echo("after parameter mashing: " + methodMatcher);
   methodMatcher = new RegExp(methodMatcher);


   // get the documentation
   var documentation = getDocumentation(
      //"g:\\project\\OneWireAPI\\src\\" +
      className.replace(/\./g,"\\") + ".java",
      methodMatcher);

   if(documentation=="")
   {
      WScript.echo();
      WScript.echo("No documentation available for method");
      WScript.echo("className="+className);
      WScript.echo("methodName="+methodName);
      WScript.echo("params="+params);
      WScript.echo("methodMatcher="+methodMatcher);
      WScript.echo();
      return "   /**\r\n    * No documentation available for method \r\n    */\r\n";
   }
   else
   {
      return documentation;
   }
}

function getClassDocumentation(className, smallClassname)
{
   var matcher = new RegExp("public.*" + smallClassname, "");
   var documentation = getDocumentation(
      //"g:\\project\\OneWireAPI\\src\\" +
      className.replace(/\./g,"\\") + ".java",
      matcher);
   if(documentation=="")
   {
      WScript.echo();
      WScript.echo("No class documentation available");
      WScript.echo("className="+className);
      WScript.echo("matcher="+matcher);
      WScript.echo();
      return "/**\r\n * No documentation available for class\r\n */\r\n";
   }
   else
   {
      return documentation;
   }
}

function getDocumentation(filename, matcher)
{
   // for removing doc'ed references to com.dalsemi.onewire packages
   var pkg = new RegExp("com\\.dalsemi\\.onewire\\..+\\.","gm");
   var documentation = "";
   var bDoc = false;
   var srcFile = fso.openTextFile(filename);
   var line = srcFile.readLine();
   for( ;!srcFile.AtEndOfStream; line = srcFile.readLine())
   {
      if(line.indexOf("/**")>=0)
      {
         bDoc = true;
      }
      if(bDoc)
      {
         documentation += line + "\r\n";
      }
      else if(line.indexOf("public")>=0)
      {
         // make sure all () are on the same line for public methods
         if(line.indexOf("(")>=0 && line.indexOf(")")<0)
         {
            var count = 0;
            while(!srcFile.AtEndOfStream && line.indexOf(")")<0)
            {
               line += srcFile.readLine();
            }
         }

         if(line.match(matcher))
         {
            // let's remove any reference to "com.dalsemi.onewire" packages from docs
            documentation = documentation.replace(pkg, "");
            return documentation;
         }
         else
            documentation = ""; //start over
      }
      else
      {
         documentation = ""; //start over
      }
      if(line.indexOf("*/")>=0)
      {
         bDoc = false;
      }
   }
   return "";
}

function getClassIDs()
{
   var classIDdict = WScript.CreateObject("Scripting.Dictionary");
   classIDdict("typelib") = "5CE02372-121E-4BCE-8774-80FBC36C509E";
   classIDdict("Address") = "0F063EEC-0277-45CB-A2A6-67EE547B65C3";
   classIDdict("Bit") = "ABF754B6-FBFA-4A6A-A714-E17F582DE3AB";
   classIDdict("ByteArray") = "5F9B0DA5-3B4E-416C-BD75-2F0A790BA907";
   classIDdict("CRC16") = "8C7253E1-34C2-4C4F-B040-8A152D7287F3";
   classIDdict("CRC8") = "D45BA87F-AC46-4CC1-8723-BDA9906BBBEC";
   classIDdict("CommandAPDU") = "B15D8BD8-0D2F-43E1-B069-AC787031E072";
   classIDdict("DSPortAdapter") = "B53517E1-D29D-47AA-A943-47A757B536B9";
   classIDdict("Debug") = "03227B5E-628A-4617-B715-C3F42D33E2A0";
   //classIDdict("DumbAdapter") = "ED127A07-47D6-4725-9A83-BB0A7823CC90";
   classIDdict("MemoryBank") = "8F4C79AC-8C69-4ED3-9AAD-1E4BFD84B4F1";
   classIDdict("MemoryBankNVCRCPW") = "C6096489-614A-4EBE-BE0F-CC24E6E4BFD6";
   classIDdict("MemoryBankScratchCRCPW") = "B387E7DA-6694-4DBD-AE71-E996A45B3234";
   classIDdict("MemoryBankScratchSHAEE") = "D72C0310-9F85-4B65-8D8E-F22EDD80DAA0";
   classIDdict("MemoryBankSHAEE") = "F93AD61A-9D4F-47DE-92D0-97668B9717D2";
   classIDdict("OTPMemoryBank") = "2417E93A-3606-4426-A5DE-D09AC41CF97F";
   classIDdict("OWPathElement") = "167FEC60-5A99-4035-B6B8-0BAAB5ED52DB";
   classIDdict("OneWireAccessProvider") = "72431E56-6797-4085-B948-B7CB7FE4BE2E";
   classIDdict("OneWireContainer") = "913956BB-CC72-4A9E-A72E-7FC13C9B3FE2";
   classIDdict("OneWireContainer01") = "0B57D987-D0A6-4C8C-A0F0-F76E16936B78";
   classIDdict("OneWireContainer02") = "D40728A2-EEE9-4F78-84BB-6AC30C0257CF";
   classIDdict("OneWireContainer04") = "4E277770-6106-4767-B5F1-16D18D9A8325";
   classIDdict("OneWireContainer05") = "269CE1C0-DC72-48DE-9768-7D7E6EC87849";
   classIDdict("OneWireContainer06") = "616EA61F-4D14-4E10-BC8D-5039384CC185";
   classIDdict("OneWireContainer08") = "F1A79462-94A5-4116-996E-1234CD338486";
   classIDdict("OneWireContainer09") = "229F18A4-E66C-46E4-B981-C0D230292F13";
   classIDdict("OneWireContainer0A") = "5A905F09-B648-4531-953A-CF936867D9C5";
   classIDdict("OneWireContainer0B") = "A7D5CE4D-CE67-461A-AC36-0ACA281BCA36";
   classIDdict("OneWireContainer0C") = "43CA34D0-862E-4E7D-B302-46EE6C53B655";
   classIDdict("OneWireContainer0F") = "B307C489-DCB9-4257-A7C1-B75FD0A65A77";
   classIDdict("OneWireContainer10") = "D502EDCE-2FE2-4059-9F70-D1FC692D7AD6";
   classIDdict("OneWireContainer12") = "340DD707-D46B-4EB1-AF28-3D1B6337B4AF";
   classIDdict("OneWireContainer13") = "1DFCFD77-42A0-4DCB-A2B4-D5DDD58C0BEE";
   classIDdict("OneWireContainer14") = "52A5B39B-55F8-46E5-AB1F-5B057EE5A35A";
   classIDdict("OneWireContainer16") = "98BA285A-4EE5-4EDF-8B97-51E87AD5FA72";
   classIDdict("OneWireContainer18") = "211176C9-8328-4DDB-B83F-A647AE95C877";
   classIDdict("OneWireContainer1A") = "26DA1D93-5997-4BAB-9777-FC101D74CE78";
   classIDdict("OneWireContainer1C") = "5130EE0C-2731-4632-9E64-57207BA612A8";
   classIDdict("OneWireContainer1D") = "8915D91D-D208-41E1-BE60-C273B366D132";
   classIDdict("OneWireContainer1F") = "13ED91C5-5252-49CC-A87C-2B71EA98B2AB";
   classIDdict("OneWireContainer20") = "6FBC3D9E-4C4E-44CD-8080-687F707DAAC3";
   classIDdict("OneWireContainer21") = "540CD168-6468-4C40-883E-BABCD0679F8D";
   classIDdict("OneWireContainer22") = "88327DF9-E07F-46BD-B94A-96B244D276A1";
   classIDdict("OneWireContainer23") = "732F307F-8955-4A19-817D-AA54F940A2B1";
   classIDdict("OneWireContainer24") = "3867DE0B-3CB9-499E-8766-71A485529B11";
   classIDdict("OneWireContainer26") = "A19AC6CC-4D56-4269-9606-B875B91E355B";
   classIDdict("OneWireContainer27") = "4C19B40E-E90A-45F7-8F52-64560C8872C4";
   classIDdict("OneWireContainer28") = "00943C11-5E36-4271-8E10-F5321D792349";
   classIDdict("OneWireContainer29") = "838A75D1-DBA5-49bf-BE21-A7EB8C166B90";
   classIDdict("OneWireContainer2C") = "28456E22-B339-4972-9173-C88235BD65A9";
   classIDdict("OneWireContainer2D") = "D07EA07D-B005-46B7-B82C-E867B66D5E8C";
   classIDdict("OneWireContainer30") = "57A521BD-0DD3-4B97-9516-F157F78CC07F";
   classIDdict("OneWireContainer33") = "CD040CDC-64D7-42A8-9776-917BD857A17F";
   classIDdict("OneWireContainer37") = "4854257B-80D8-4DE5-A6A5-E39D195F6FBC";
   classIDdict("OneWireContainer3A") = "FE281E1B-F3B1-4370-B64E-3A8DA68E662C";
   classIDdict("OneWireContainer41") = "12A37CC5-5D4E-450d-8C24-652018EF5C32";
   classIDdict("PagedMemoryBank") = "1C81A772-4E72-4E0D-847B-0F5E3093F8B4";
   classIDdict("ResponseAPDU") = "E7634208-5586-4162-95CD-57769B7DB83F";
   //classIDdict("SHAiButton") = "6E77ABDC-C86C-44AF-B518-7F63CFE500D7";
   //classIDdict("SHAiButtonVM") = "4EE0AFB8-EF60-427A-BC81-FEB85F706E3B";
   //classIDdict("TMEXAdapter") = "BC47B8E7-D5A9-4A22-AEEC-023C047D34CB";
   //classIDdict("USerialAdapter") = "AB1C00B6-C6E0-4AC7-BDEE-0940EDDC2905";

   //classIDdict("LSerialAdapter") = "8CC126F9-E215-4E40-B7FE-E1783EF8AACA";
   classIDdict("MulticastListener") = "F5FA1E55-C5D3-48F9-8185-3E3D33C83F8B";
   classIDdict("NetAdapter") = "44E0AE2A-B1F3-4E6E-8524-A0DABA72B152";
   classIDdict("NetAdapterHost") = "BB43F1B4-5B7A-4F84-AB25-90554A26AE0D";
   classIDdict("OWFile") = "BC50B502-FFA1-499C-A983-A6E7B12D78BB";
   classIDdict("OWFileDescriptor") = "0B882ED5-740F-440A-8C81-536FB36D406A";
   classIDdict("OWFileInputStream") = "5B7589D2-A1BB-4443-8EC7-7C801CA6CC6E";
   classIDdict("OWFileOutputStream") = "6B53A2E8-C9E3-4A11-B271-C1575D546ACF";
   classIDdict("SHADebit") = "6082CB41-FE26-4BCB-A845-BEF4AA86347A";
   classIDdict("SHADebitUnsigned") = "86927404-D640-4C08-A651-DB55CE592854";
   classIDdict("SHAiButtonCopr") = "BA8CF6FA-7E10-4DAE-B611-AF7A96EBDA18";
   classIDdict("SHAiButtonCoprVM") = "AFDB0D37-D471-4597-B17F-D28D2D42356B";
   classIDdict("SHAiButtonUser") = "5CE2324F-5BC4-47F1-91E8-DADADF0B46AF";
   classIDdict("SHAiButtonUser18") = "DAAE37E9-CA16-422E-946D-22B1C0D2CFA4";
   classIDdict("SHAiButtonUser33") = "611EB244-C952-45A9-9BC4-6642B66027B5";
   classIDdict("SHATransaction") = "91435CC5-B687-4DAE-9A3A-9E645455F306";
   classIDdict("SHASoftAuth") = "7B47F576-B1FF-45C4-A1EC-B59EE993DF65";
   classIDdict("Contact") = "0AD2E0E0-2D97-4568-9ABE-A1A68806E1A8";
   classIDdict("D2A") = "5178938A-06FC-47FA-B324-06B1E63F89C9";
   classIDdict("Humidity") = "A1A2B487-4D45-4C89-95D1-C915432A771B";
   classIDdict("SAXParser") = "995AE924-D4A0-4E90-BB36-AE903BF5DBAC";
   classIDdict("Switch") = "95D16ECB-CFD8-4858-A569-CCB4C977DC11";
   classIDdict("Level") = "84A459B4-8081-4CE7-9354-00BFFC1EE464";
   classIDdict("TaggedDevice") = "AA632CE1-28A2-4C2E-B73F-AC7130AEF6CD";
   classIDdict("TAGParser") = "1A5F657A-FDD0-4C30-BD32-AAFCEDD74E52";
   classIDdict("Thermal") = "2CC4E7C1-18F7-4654-8E72-2C12437EB95F";
   classIDdict("XML") = "199E86B6-027D-4569-82D8-16879B66CA0F";
   classIDdict("JibComm") = "58720074-BF3D-481A-8D9D-E904F39AAC37";
   classIDdict("Convert") = "9501221D-177A-4230-8B25-0DD821F58166";
   classIDdict("OWPath") = "95D46B7C-0D35-470E-BF91-90A1E0E5EF7B";
   classIDdict("SHA") = "0247116E-6589-4B5B-A857-D5FF4BB0E343";

   //Do not add the AbstractDeviceMonitor to the COM DLL, just the class library
   //for the benefit of the two subclasses
   //classIDdict("AbstractDeviceMonitor") = "9581A0E1-E081-4004-8374-962573128D0FE";
   classIDdict("DeviceMonitor") = "D6A33CDB-44A1-4653-BA4A-317F3DA7DBCE";
   classIDdict("NetworkDeviceMonitor") = "CA919A7E-19A9-4826-84AD-5DD6D599DF9D";

   return classIDdict;
}



/*
var pkg = "";
for(var i=0; i<keys.length; i++)
{
   var j = keys[i].lastIndexOf(".");
   if(pkg != keys[i].substring(0,j))
   {
      pkg = keys[i].substring(0,j);
      WScript.echo("   ");
      WScript.echo("   //" + pkg);
   }
   WScript.echo("   dispinterface " + keys[i].substring(j+1) + "_Dispatch;");
}
*/
/*
for(var i=0; i<keys.length; i++)
{
   var className = keys[i];
   var j = className.lastIndexOf(".");
   var methods = dict(className)("methods");
   WScript.echo("   dispinterface " + className.substring(j+1) + "_Dispatch {");
   WScript.echo("properties:");
   WScript.echo("methods:");
   for(var j=0; j<methods.length; j++)
   {
      WScript.echo(methods[j]);
   }
   WScript.echo("};");
}
*/

/*
for(var i=0; i<keys.length; i++)
{
   var className = keys[i];

   WScript.echo("// ************************************************************ ");
   WScript.echo("// Begin COM Methods");
   WScript.echo("//   For " + className);
   WScript.echo("// ************************************************************ ");

   var a = dict(className);
   var methods = a("methods");

   //of the collection of methods, we're only interested in
   //methods that don't exist in a super class
   var uniqueMethods = checkSuper(a("extends"),methods);

   for(var j=0; j<uniqueMethods.length; j++)
   {
      var sMethodSig = uniqueMethods[j];

      //only generating proxy methods for "long" and "byte[]"
      if(sMethodSig.indexOf("byte[]")>=0 || sMethodSig.indexOf("long")>=0)
      {
         var reg = new RegExp("(.*)\\((.*)\\)([\\[\\]]*)(.*)","g")
         sMethodSig.match(reg);

         var sMethodName = RegExp.$1;
         var sParams = RegExp.$2;
         var sThrows = RegExp.$4;

         var arrMethodName = sMethodName.split(" ");

         if(RegExp.$3)
         {
            arrMethodName[1] += RegExp.$3;
            sMethodName = (String(arrMethodName)).replace(/,/g," ");
         }

         //Check the return value
         var sNewMethodName = "";
         if(arrMethodName[1] == "long")
            sNewMethodName += (sMethodName).replace("long","String");
         else
            sNewMethodName += sMethodName
         sNewMethodName += "COM";

         //build the argument list for the method we're calling
         var sMethodCallArgs = "";
         // and the parameter list for the method we're writing
         var sNewMethodParams = "";
         if(sParams.indexOf("byte[]")>=0 || sParams.indexOf("long")>=0 )
         {
            var arrParams = sParams.split(", ");
            sNewMethodParams = COMtype(arrParams[0]) + " a0";
            sMethodCallArgs += unCOMtype(arrParams[0], "a0");
            for(var t=1; t<arrParams.length; t++)
            {
               sNewMethodParams += ", " + COMtype(arrParams[t]) + " a" + t;
               sMethodCallArgs += ", " + unCOMtype(arrParams[t], "a" + t);
            }
         }

         //build the new proxy method
         var sNewMethod = "   " + sNewMethodName + "(" + sNewMethodParams + ")\n"
         if(sThrows.indexOf("throws")>=0)
            sNewMethod += "      " + sThrows + "\n";
         sNewMethod += "   {      \n         ";
         if(arrMethodName[1]=="long")
            sNewMethod += "return \"\"+";
         else if(arrMethodName[1]!="void")
            sNewMethod += "return ";
         sNewMethod += sMethodName.substring(sMethodName.lastIndexOf(" ")+1);
         sNewMethod += "(" + sMethodCallArgs + ");\n";
         sNewMethod += "   }\n";

         WScript.echo(sNewMethod);
      }
   }
   WScript.echo("// ************************************************************ ");
   WScript.echo("// End COM Methods");
   WScript.echo("// ************************************************************ ");
}
*/
WScript.echo("done");

function COMtype(strType)
{
   if(strType=="byte[]")
   {
      return "ByteArray";
   }
   else if(strType=="boolean[]")
   {
      return "BooleanArray";
   }
   else if(strType=="long[]")
   {
      return "LongArray";
   }
   else if(strType=="int[]")
   {
      return "IntArray";
   }
   else if(strType=="char[]")
   {
      return "CharArray";
   }
   else if(strType=="float[]")
   {
      return "FloatArray";
   }
   else if(strType=="double[]")
   {
      return "DoubleArray";
   }
   else if(strType=="com.dalsemi.onewire.container.OneWireContainer[]")
   {
      return "OneWireContainerArray";
   }
   else if(strType=="com.dalsemi.onewire.application.file.OWFile[]")
   {
      return "OWFileArray";
   }
   else if(strType=="long")
   {
      return "String";
   }
   else
      return strType;
}
function unCOMtype(strType, strVar)
{
   if(strType=="byte[]" || strType=="boolean[]" || strType=="long[]" || strType=="int[]"
      || strType=="double[]" || strType=="float[]" 
      || strType=="com.dalsemi.onewire.container.OneWireContainer[]"
      || strType=="com.dalsemi.onewire.application.file.OWFile[]")
   {
      return strVar + ".array";
   }
   else if(strType=="long")
   {
      return "Long.parseLong(" + strVar + ")";
   }
   else
      return strVar;
}

function checkSuper(className,methods)
{
   var superDict = dict(className);
   if(typeof superDict != "undefined")
   {
      var superMethods = superDict("methods");
      var uniqueMethods = new Array();
      for(var k=0; k<methods.length; k++)
      {
         var unique = true;
         for(var l=0; l<superMethods.length; l++)
         {
            if(methods[k]==superMethods[l])
            {
               unique = false;
               l = superMethods.length;
            }

         }
         if(unique)
            uniqueMethods[uniqueMethods.length] = methods[k];
      }
      return checkSuper(superDict("extends"),uniqueMethods);
   }
   else
      return methods;
}

function getAdditionalMethods(className)
{
   var methStr = "";
   if(className=="com.dalsemi.onewire.container.OneWireContainer")
   {
      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the ClockContainer interface.\n";
      methStr += "    * @see owapi.ClockContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isClockContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.ClockContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the TemperatureContainer interface.\n";
      methStr += "    * @see owapi.TemperatureContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isTemperatureContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.TemperatureContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the SwitchContainer interface.\n";
      methStr += "    * @see owapi.SwitchContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isSwitchContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.SwitchContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the HumidityContainer interface.\n";
      methStr += "    * @see owapi.HumidityContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isHumidityContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.HumidityContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the ADContainer interface.\n";
      methStr += "    * @see owapi.ADContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isADContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.ADContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the PotentiometerContainer interface.\n";
      methStr += "    * @see owapi.PotentiometerContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isPotentiometerContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.PotentiometerContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the MissionContainer interface.\n";
      methStr += "    * @see owapi.MissionContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isMissionContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.MissionContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the PasswordContainer interface.\n";
      methStr += "    * @see owapi.PasswordContainer\n";
      methStr += "    */\n";
      methStr += "   public boolean isPasswordContainer()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.PasswordContainer);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * If this class is an instance of OneWireContainer, this method will return the most specific\n";
      methStr += "    * OneWireContainer class.  For example, for a DS1963S, this method will return an instance of\n";
      methStr += "    * OneWireContainer16.\n";
      methStr += "    */\n";
      methStr += "   public OneWireContainer getMostSpecificComponent()\n";
      methStr += "   {\n";
      methStr += "      OneWireContainer owc = this;\n";
      methStr += getRetypeLogic("OneWireContainer","objectInstance","owc", true) + "\n"
      methStr += "      return owc;\n";
      methStr += "   }\n\n";
      
      methStr += "   /**\n";
      methStr += "    * This method will define this object to hold the same OneWireContainer object as the one\n";
      methStr += "    * passed in.  This is used in early binding, where you create the specific type first, then\n";
      methStr += "    * initialize it with a type returned from another method in the API.\n";
      methStr += "    */\n";
      methStr += "   public void buildFromObject(OneWireContainer buildOWC)\n";
      methStr += "   {\n";
      methStr += "      this.objectInstance = buildOWC.objectInstance;\n";
      methStr += "   }\n\n";
   }
   else if(className=="com.dalsemi.onewire.container.MemoryBank")
   {
      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the PagedMemoryBank.\n";
      methStr += "    * @see owapi.PagedMemoryBank\n";
      methStr += "    */\n";
      methStr += "   public boolean isPagedMemoryBank()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.PagedMemoryBank);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * Indicates whether or not this class implements the methods defined in the OTPMemoryBank.\n";
      methStr += "    * @see owapi.OTPMemoryBank\n";
      methStr += "    */\n";
      methStr += "   public boolean isOTPMemoryBank()\n";
      methStr += "   {\n";
      methStr += "      return (this.objectInstance instanceof com.dalsemi.onewire.container.OTPMemoryBank);\n";
      methStr += "   }\n\n";

      methStr += "   /**\n";
      methStr += "    * If this class is an instance of MemoryBank, this method will return the most specific\n";
      methStr += "    * MemoryBank class, such as OTPMemoryBank or PagedMemoryBank.\n";
      methStr += "    */\n";
      methStr += "   public MemoryBank getMostSpecificComponent()\n";
      methStr += "   {\n";
      methStr += "      MemoryBank mb = this;\n";
      methStr += getRetypeLogic("MemoryBank","objectInstance","mb", true) + "\n"
      methStr += "      return mb;\n";
      methStr += "   }\n\n";
      
      methStr += "   /**\n";
      methStr += "    * This method will define this object to hold the same MemoryBank object as the one\n";
      methStr += "    * passed in.  This is used in early binding, where you create the specific type first, then\n";
      methStr += "    * initialize it with a type returned from another method in the API.\n";
      methStr += "    */\n";
      methStr += "   public void buildFromObject(MemoryBank buildMB)\n";
      methStr += "   {\n";
      methStr += "      this.objectInstance = buildMB.objectInstance;\n";
      methStr += "   }\n\n";
   }
/*   else if(className=="com.dalsemi.onewire.adapter.DSPortAdapter")
   {
      methStr += "   public DSPortAdapter getMostSpecificComponent()\n";
      methStr += "   {\n";
      methStr += "      DSPortAdapter dspa = this;\n";
      methStr += getRetypeLogic("DSPortAdapter","objectInstance","dspa", true) + "\n"
      methStr += "      return dspa;\n";
      methStr += "   }\n\n";
   }*/

   return methStr;
}

function getRetypeLogic(retype, varName, saveVarName, hideLastElse)
{
   var typeStr = null;
   if(retype=="DSPortAdapter")
   {
      //typeStr = "";
      //typeStr += "         if(" + varName + " instanceof com.dalsemi.onewire.adapter.TMEXAdapter)\n";
      //typeStr += "            " + saveVarName + " = new TMEXAdapter(" + varName + ");\n";
      //if(hideLastElse!=true)
      //{
      //   typeStr += "         else \n";
         typeStr = "         " + saveVarName + " = new DSPortAdapter(" + varName + ");\n";
      //}
   }
   else if(retype=="MemoryBank")
   {
      typeStr = "\n";
      typeStr += "         if(" + varName + " instanceof com.dalsemi.onewire.container.OTPMemoryBank)\n";
      typeStr += "            " + saveVarName + " = new OTPMemoryBank(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.PagedMemoryBank)\n";
      typeStr += "            " + saveVarName + " = new PagedMemoryBank(" + varName + ");\n";
      if(hideLastElse!=true)
      {
         typeStr += "         else \n";
         typeStr += "            " + saveVarName + " = new MemoryBank(" + varName + ");\n";
      }
   }
   else if(retype=="OWPath")
   {
      typeStr = "         " + saveVarName + " = new OWPath(" + varName + ");\n"
   }
   else if(retype=="OWFile")
   {
      typeStr = "         " + saveVarName + " = new OWFile(" + varName + ");\n"
   }
   else if(retype=="OneWireContainer")
   {
      typeStr = "\n";
      typeStr += "         if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer01)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer01(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer02)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer02(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer04)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer04(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer05)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer05(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer06)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer06(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer08)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer08(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer09)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer09(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer0A)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer0A(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer0B)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer0B(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer0C)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer0C(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer0F)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer0F(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer10)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer10(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer12)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer12(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer13)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer13(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer14)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer14(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer16)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer16(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer18)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer18(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer1A)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer1A(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer1D)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer1D(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer1F)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer1F(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer20)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer20(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer21)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer21(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer23)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer23(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer26)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer26(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer28)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer28(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer29)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer29(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer2C)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer2C(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer30)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer30(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer33)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer33(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer37)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer37(" + varName + ");\n";
      typeStr += "         else if(" + varName + " instanceof com.dalsemi.onewire.container.OneWireContainer41)\n";
      typeStr += "            " + saveVarName + " = new OneWireContainer41(" + varName + ");\n";
      if(hideLastElse!=true)
      {
         typeStr += "         else \n";
         typeStr += "            " + saveVarName + " = new OneWireContainer(" + varName + ");\n";
      }
   }
   return typeStr;
}
