// COM proxy class, output from FunctionList.js
package owapi;
/**
 * This class provides a default object for the Contact type of a tagged 1-Wire device.
 * @com.register ( clsid=0AD2E0E0-2D97-4568-9ABE-A1A68806E1A8, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 * @version CLSID=0AD2E0E0-2D97-4568-9ABE-A1A68806E1A8
 */
public class Contact
   extends TaggedDevice
   implements com.ms.com.IUnknown
{

   //Instance defined in super class: TaggedDevice
   //com.dalsemi.onewire.application.tag.Contact objectInstance  = null;

   /**
    * Default constructor. Does nothing. Use createNewInstance methods to call a specific constructor.
    */
   public Contact()
   {
      super(new com.dalsemi.onewire.application.tag.Contact());
   }

   Contact(com.dalsemi.onewire.application.tag.Contact o)
   {
      super(o);
   }
   Contact(java.lang.Object o)
   {
      super((com.dalsemi.onewire.application.tag.Contact)o);
   }

   /**
    * Creates an object for the device with the supplied address and device type connected
    * to the supplied port adapter.
    * @param adapter The adapter serving the sensor.
    * @param NetAddress The 1-Wire network address of the sensor.
    * @param netAddress
    */
   public void createNewInstance(DSPortAdapter adapter, java.lang.String netAddress)
   {      
      objectInstance = new com.dalsemi.onewire.application.tag.Contact(((com.dalsemi.onewire.adapter.DSPortAdapter)adapter.objectInstance), netAddress);
   }

   /**
    * The readSensor method returns the "max" string if the Sensor is
    * present or the "min" string if the Sensor is not present.
    * @param--none.
    *
    * @return The "max" string if sensor is present or "min" string if not.
    */
   public java.lang.String readSensor()
      throws com.dalsemi.onewire.OneWireException
   {      
      return ((com.dalsemi.onewire.application.tag.Contact)objectInstance).readSensor();
   }



   /** Sets this object's reference to null */
   public void freeObject()
   {
      this.objectInstance = null;
   }

   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.objectInstance != null;
   }

   TaggedDevice setupObject(Object o)
   {
      this.objectInstance = (com.dalsemi.onewire.application.tag.Contact)o;
      return this;
   }
}
