// COM proxy class, output from FunctionList.js
package owapi;
/**
 * This class provides a default object for the Level type of a tagged 1-Wire device.
 * @com.register ( clsid=84A459B4-8081-4CE7-9354-00BFFC1EE464, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 * @version CLSID=84A459B4-8081-4CE7-9354-00BFFC1EE464
 */
public class Level
   extends TaggedDevice
   implements com.ms.com.IUnknown
{

   //Instance defined in super class: TaggedDevice
   //com.dalsemi.onewire.application.tag.Level objectInstance  = null;

   /**
    * Default constructor. Does nothing. Use createNewInstance methods to call a specific constructor.
    */
   public Level()
   {
      super(new com.dalsemi.onewire.application.tag.Level());
   }

   Level(com.dalsemi.onewire.application.tag.Level o)
   {
      super(o);
   }
   Level(java.lang.Object o)
   {
      super((com.dalsemi.onewire.application.tag.Level)o);
   }

   /**
    * Creates an object for the device with the supplied address and device type connected
    * to the supplied port adapter.
    * @param adapter The adapter serving the sensor.
    * @param netAddress The 1-Wire network address of the sensor.
    *
    */
   public void createNewInstance(DSPortAdapter adapter, java.lang.String netAddress)
   {      
      objectInstance = new com.dalsemi.onewire.application.tag.Level(((com.dalsemi.onewire.adapter.DSPortAdapter)adapter.objectInstance), netAddress);
   }

   /**
    * The readSensor method returns the <max> or <min> string of the Sensor (in 
    * this case, a switch).  The elements <max> and <min> represent conducting 
    * and non-conducting states of the switch, respectively. 
    *
    * @param--none.
    *
    * @return String  The <max> string is associated with the conducting switch state,
    *                 and the <min> string is associated with the non-conducting state 
    *                 of the 1-Wire switch.
    */
   public java.lang.String readSensor()
      throws com.dalsemi.onewire.OneWireException
   {      
      return ((com.dalsemi.onewire.application.tag.Level)objectInstance).readSensor();
   }



   /** Sets this object's reference to null */
   public void freeObject()
   {
      this.objectInstance = null;
   }

   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.objectInstance != null;
   }

   TaggedDevice setupObject(Object o)
   {
      this.objectInstance = (com.dalsemi.onewire.application.tag.Level)o;
      return this;
   }
}
