package owapi;

/**
 *
 *<P><H3>COM: TYPELIB=5CE02372-121E-4BCE-8774-80FBC36C509E, CLSID=8A0171B0-7041-40ed-919F-4A0CAE343EEA</H3></P>
 *
 * Utility class, replaces any occurrence of "java.util.Enumeration" in COM 
 * code when that Enumeration is a collection of MemoryBank objects
 *
 * @version CLSID=8A0171B0-7041-40ed-919F-4A0CAE343EEA - 1.00
 * @com.register ( clsid=8A0171B0-7041-40ed-919F-4A0CAE343EEA, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 */
public class MemoryBankEnumeration
   implements com.ms.com.IUnknown
{
   java.util.Enumeration enum = null;
   
   /**
    * Returns boolean at the specified index.
    * @param index the index to retrieve element
    * @return the value at the specified index
    */
   public MemoryBank nextElement()
   {
      return (MemoryBank)enum.nextElement();
   }

   /**
    * Returns boolean at the specified index.
    * @param index the index to retrieve element
    * @return the value at the specified index
    */
   public boolean hasMoreElements()
   {
      return enum.hasMoreElements();
   }
   
   
   /**
    * Used to build from an actual enumeration returned from a Java object
    */
   public void buildFromObject(Object buildObj)
   {
      this.enum = ((MemoryBankEnumeration)buildObj).enum;
   }

   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.enum != null;
   }

   MemoryBankEnumeration setupObject(Object o)
   {
      java.util.Enumeration retEnum = (java.util.Enumeration)o;
      java.util.Vector reRetEnum = new java.util.Vector();
      while(retEnum.hasMoreElements())
      {
         Object obj = retEnum.nextElement();

         if(obj instanceof com.dalsemi.onewire.container.OTPMemoryBank)
            obj = new OTPMemoryBank(obj);
         else if(obj instanceof com.dalsemi.onewire.container.PagedMemoryBank)
            obj = new PagedMemoryBank(obj);
         else 
            obj = new MemoryBank(obj);

         reRetEnum.addElement(obj);         
      }
      this.enum = reRetEnum.elements();
      return this;
   }
}
