// COM proxy class, output from FunctionList.js
package owapi;
/**
 * Generic Mulitcast broadcast listener.  Listens for a specific message and,
 * in response, gives the specified reply.  Used by NetAdapterHost for
 * automatic discovery of host components for the network-based DSPortAdapter.
 *
 * @author SH
 * @version CLSID=F5FA1E55-C5D3-48F9-8185-3E3D33C83F8B -  1.00
 * @com.register ( clsid=F5FA1E55-C5D3-48F9-8185-3E3D33C83F8B, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 */
public class MulticastListener
   implements com.ms.com.IUnknown
{

   com.dalsemi.onewire.adapter.MulticastListener objectInstance  = null;

   /**
    * Default constructor. Does nothing. Use createNewInstance methods to call a specific constructor.
    */
   public MulticastListener()
   {
   }

   MulticastListener(com.dalsemi.onewire.adapter.MulticastListener o)
   {
      this.objectInstance = o;
   }
   MulticastListener(java.lang.Object o)
   {
      this.objectInstance = ((com.dalsemi.onewire.adapter.MulticastListener)o);
   }

   /**
    * Creates a multicast listener on the specified multicast port,
    * bound to the specified multicast group.  Whenever the byte[]
    * pattern specified by "expectedMessage" is received, the byte[]
    * pattern specifed by "returnMessage" is sent to the sender of
    * the "expected message".
    *
    * @param multicastPort Port to bind this listener to.
    * @param multicastGroup Group to bind this listener to.
    * @param expectedMessage the message to look for
    * @param returnMessage the message to reply with
    */
   public void createNewInstance(int multicastPort, java.lang.String multicastGroup, ByteArray expectedMessage, ByteArray returnMessage)
      throws java.io.IOException, java.net.UnknownHostException
   {      
      objectInstance = new com.dalsemi.onewire.adapter.MulticastListener(multicastPort, multicastGroup, expectedMessage.array, returnMessage.array);
   }

   /**
    * Run method waits for Multicast packets with the specified contents
    * and replies with the specified message.
    */
   public void run()
   {      
      objectInstance.run();
   }

   /**
    * Waits for datagram listener to finish, with a timeout.
    */
   public void stopListener()
   {      
      objectInstance.stopListener();
   }



   /** Sets this object's reference to null */
   public void freeObject()
   {
      this.objectInstance = null;
   }

   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.objectInstance != null;
   }

   MulticastListener setupObject(Object o)
   {
      this.objectInstance = (com.dalsemi.onewire.adapter.MulticastListener)o;
      return this;
   }
}
