package owapi;

/**
 *
 *<P><H3>COM: TYPELIB=5CE02372-121E-4BCE-8774-80FBC36C509E, CLSID=1C67D740-B681-4099-9B3A-7BE559A79D98</H3></P>
 *
 * Utility class, replaces any occurrence of "OWFile[]" in COM code
 *
 * @version CLSID=1C67D740-B681-4099-9B3A-7BE559A79D98 - 1.00
 * @com.register ( clsid=1C67D740-B681-4099-9B3A-7BE559A79D98, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 */
public class OWFileArray
   implements com.ms.com.IUnknown
{
   com.dalsemi.onewire.application.file.OWFile[] array = null;
   
   /**
    * Returns the internal array, for scripting languages where using the array
    * is user than using this helper
    * @return OWFile[] the internal array this class is wrapping
    */
   public OWFile[] unwrap()
   {
      OWFile[] owf = new OWFile[this.array.length];
      for(int i=0; i<owf.length; i++)
         owf[i] = getAt(i);
      return owf;
   }
   
   /**
    * Sets the internal array, for scripting languages where using the array
    * is easier than using this helper
    * @param newArray new internal array
    */
   public void wrap(OWFile[] newArray)
   {
      this.array = new com.dalsemi.onewire.application.file.OWFile[newArray.length];
      for(int i=0; i<this.array.length; i++)
         this.array[i] = newArray[i].objectInstance;
   }

   /**
    * Returns boolean at the specified index.
    * @param index the index to retrieve element
    * @return the value at the specified index
    */
   public OWFile getAt(int index)
   {
      return new OWFile().setupObject(array[index]);
   }
   
   /**
    * Sets the element at the specified index.
    * @param index the index to retrieve element
    * @param value the new value
    */
   public void setAt(int index, OWFile value)
   {
      array[index] = value.objectInstance;
   }


   /**
    * Sets the size of the boolean[]
    * @param size the new size
    */
   public void setSize(int size)
   {
      com.dalsemi.onewire.application.file.OWFile[] tmp = array;
      array = new com.dalsemi.onewire.application.file.OWFile[size];
      if(tmp!=null)
         System.arraycopy(tmp,0,array,0,Math.min(tmp.length,size));
   }

   /**
    * Returns the size of the boolean[]
    * @param size the new size
    */
   public int getSize()
   {
      return array.length;
   }

   /**
    * Converts the boolean[] to a string
    * @return boolean[] as a string
    */
   public String toString()   
   {
      StringBuffer sb = new StringBuffer(7*array.length);
      for (int i = 0; i < array.length; i++)
      {
         if(i>0)
            sb.append(", ");
         sb.append(array[i].toString());
      }

      return sb.toString();
   }
   
   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.array != null;
   }
   
   /**
    * Used to build from an actual array returned from a Java object
    */
   public void buildFromObject(Object buildObj)
   {
      if(buildObj instanceof OWFileArray)
      {
         this.array = ((OWFileArray)buildObj).array;
      }
      else if(buildObj instanceof com.dalsemi.onewire.application.file.OWFile[])
      {
         this.array = (com.dalsemi.onewire.application.file.OWFile[])
                       ((com.dalsemi.onewire.application.file.OWFile[])buildObj).clone();
      }
      else if(buildObj instanceof OWFile[])
      {
         OWFile[] tmp = (OWFile[])buildObj;
         this.array = new com.dalsemi.onewire.application.file.OWFile[tmp.length];
         for(int i=0; i<tmp.length; i++)
            this.array[i] = tmp[i].objectInstance;
      }
   }

   OWFileArray setupObject(Object o)
   {
      this.array = (com.dalsemi.onewire.application.file.OWFile[])o;
      return this;
   }
}
