// COM proxy class, output from FunctionList.js
package owapi;
/**
 * <P>1-Wire&#174 container that encapsulates the functionality of the 1-Wire
 * family type <B>01</B> (hex), Dallas Semiconductor part number: <B>DS1990A,
 * Serial Number</B>.</P>
 *
 * <P> This 1-Wire device is used as a unique serial number. </P>
 *
 * <H2> Features </H2>
 * <UL>
 *   <LI> 64 bit unique serial number
 *   <LI> Operating temperature range from -40&#176C to
 *        +85&#176C
 * </UL>
 *
 * <H2> Alternate Names </H2>
 * <UL>
 *   <LI> DS2401
 *   <LI> DS1420 (Family 81)
 * </UL>
 *
 * <H2> DataSheets </H2>
 *
 *   <A HREF="http://pdfserv.maxim-ic.com/arpdf/DS1990A.pdf"> http://pdfserv.maxim-ic.com/arpdf/DS1990A.pdf</A><br>
 *   <A HREF="http://pdfserv.maxim-ic.com/arpdf/DS2401.pdf"> http://pdfserv.maxim-ic.com/arpdf/DS2401.pdf</A><br>
 *   <A HREF="http://pdfserv.maxim-ic.com/arpdf/DS1420.pdf"> http://pdfserv.maxim-ic.com/arpdf/DS1420.pdf</A>
 *
 *  @version CLSID=0B57D987-D0A6-4C8C-A0F0-F76E16936B78 -     0.00, 28 Aug 2000
 *  @author     DS
 * @com.register ( clsid=0B57D987-D0A6-4C8C-A0F0-F76E16936B78, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 */
public class OneWireContainer01
   extends OneWireContainer
   implements com.ms.com.IUnknown
{

   //Instance defined in super class: OneWireContainer
   //com.dalsemi.onewire.container.OneWireContainer01 objectInstance  = null;

   /**
    * Default constructor. Does nothing. Use setupContainer or buildFromObject methods initialize.
    */
   public OneWireContainer01()
   {
      super(new com.dalsemi.onewire.container.OneWireContainer01());
   }

   OneWireContainer01(com.dalsemi.onewire.container.OneWireContainer01 o)
   {
      super(o);
   }
   OneWireContainer01(java.lang.Object o)
   {
      super((com.dalsemi.onewire.container.OneWireContainer01)o);
   }



   /** Sets this object's reference to null */
   public void freeObject()
   {
      this.objectInstance = null;
   }

   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.objectInstance != null;
   }

   OneWireContainer setupObject(Object o)
   {
      this.objectInstance = (com.dalsemi.onewire.container.OneWireContainer01)o;
      return this;
   }
}
