// COM proxy class, output from FunctionList.js
package owapi;
/**
 * This class provides a default object for the Switch type of a tagged 1-Wire device.
 * @com.register ( clsid=95D16ECB-CFD8-4858-A569-CCB4C977DC11, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 * @version CLSID=95D16ECB-CFD8-4858-A569-CCB4C977DC11
 */
public class Switch
   extends TaggedDevice
   implements com.ms.com.IUnknown
{

   //Instance defined in super class: TaggedDevice
   //com.dalsemi.onewire.application.tag.Switch objectInstance  = null;

   /**
    * Default constructor. Does nothing. Use createNewInstance methods to call a specific constructor.
    */
   public Switch()
   {
      super(new com.dalsemi.onewire.application.tag.Switch());
   }

   Switch(com.dalsemi.onewire.application.tag.Switch o)
   {
      super(o);
   }
   Switch(java.lang.Object o)
   {
      super((com.dalsemi.onewire.application.tag.Switch)o);
   }

   /**
    * Creates an object for the device with the supplied address connected
    * to the supplied port adapter.
    * @param adapter The adapter serving the actuator.
    * @param netAddress The 1-Wire network address of the actuator.
    */
   public void createNewInstance(DSPortAdapter adapter, java.lang.String netAddress)
   {      
      objectInstance = new com.dalsemi.onewire.application.tag.Switch(((com.dalsemi.onewire.adapter.DSPortAdapter)adapter.objectInstance), netAddress);
   }

   /**
    * Get the possible selection states of this actuator
    *
    * @return Vector of Strings representing selection states.
    */
   public java.util.Vector getSelections()
   {      
      return ((com.dalsemi.onewire.application.tag.Switch)objectInstance).getSelections();
   }

   /**
    * Set the selection of this actuator
    *
    * @param The selection string.
    *
    * @throws OneWireException
    *
    */
   public void setSelection(java.lang.String selection)
      throws com.dalsemi.onewire.OneWireException
   {      
      ((com.dalsemi.onewire.application.tag.Switch)objectInstance).setSelection(selection);
   }

   /**
    * Initializes the actuator
    * @param Init The initialization string.
    *
    * @throws OneWireException
    * 
    */
   public void initActuator()
      throws com.dalsemi.onewire.OneWireException
   {      
      ((com.dalsemi.onewire.application.tag.Switch)objectInstance).initActuator();
   }



   /** Sets this object's reference to null */
   public void freeObject()
   {
      this.objectInstance = null;
   }

   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.objectInstance != null;
   }

   TaggedDevice setupObject(Object o)
   {
      this.objectInstance = (com.dalsemi.onewire.application.tag.Switch)o;
      return this;
   }
}
