// COM proxy class, output from FunctionList.js
package owapi;
/**
 * This class provides a default object for the Thermal type of a tagged 1-Wire device.
 * @com.register ( clsid=2CC4E7C1-18F7-4654-8E72-2C12437EB95F, typelib=5CE02372-121E-4BCE-8774-80FBC36C509E )
 * @version CLSID=2CC4E7C1-18F7-4654-8E72-2C12437EB95F
 */
public class Thermal
   extends TaggedDevice
   implements com.ms.com.IUnknown
{

   //Instance defined in super class: TaggedDevice
   //com.dalsemi.onewire.application.tag.Thermal objectInstance  = null;

   /**
    * Default constructor. Does nothing. Use createNewInstance methods to call a specific constructor.
    */
   public Thermal()
   {
      super(new com.dalsemi.onewire.application.tag.Thermal());
   }

   Thermal(com.dalsemi.onewire.application.tag.Thermal o)
   {
      super(o);
   }
   Thermal(java.lang.Object o)
   {
      super((com.dalsemi.onewire.application.tag.Thermal)o);
   }

   /**
    * Creates an object for the device with the supplied address and device type connected
    * to the supplied port adapter.
    * @param adapter The adapter serving the sensor.
    * @param netAddress The 1-Wire network address of the sensor.
    */
   public void createNewInstance(DSPortAdapter adapter, java.lang.String netAddress)
   {      
      objectInstance = new com.dalsemi.onewire.application.tag.Thermal(((com.dalsemi.onewire.adapter.DSPortAdapter)adapter.objectInstance), netAddress);
   }

   /**
    * The readSensor method returns a temperature in degrees Celsius 
    *
    * @param--none.
    *
    * @return String temperature in degrees Celsius
    */
   public java.lang.String readSensor()
      throws com.dalsemi.onewire.OneWireException
   {      
      return ((com.dalsemi.onewire.application.tag.Thermal)objectInstance).readSensor();
   }



   /** Sets this object's reference to null */
   public void freeObject()
   {
      this.objectInstance = null;
   }

   /** Returns true if this COM Stub class refers to an object which is not null */
   public boolean isObjectInitialized()
   {
      return this.objectInstance != null;
   }

   TaggedDevice setupObject(Object o)
   {
      this.objectInstance = (com.dalsemi.onewire.application.tag.Thermal)o;
      return this;
   }
}
